std::discrete_distribution< _IntType >(3cxx)

NAME
std::discrete_distribution< _IntType > - A discrete_distribution random number distribution.

SYNOPSIS

#include <random>

  Classes

struct param_type

  Public Types

typedef _IntType result_type

  Public Member Functions

template<typename _InputIterator > discrete_distribution (_InputIterator __wbegin, _InputIterator __wend)
discrete_distribution (const param_type &__p)
discrete_distribution (initializer_list< double > __wl)
template<typename _Func > discrete_distribution (size_t __nw, double __xmin, double __xmax, _Func __fw)
template<typename _ForwardIterator , typename _UniformRandomNumberGenerator > void __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng)
template<typename _ForwardIterator , typename _UniformRandomNumberGenerator > void __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
template<typename _UniformRandomNumberGenerator > void __generate (result_type *__f, result_type *__t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
result_type max () const
Returns the least upper bound value of the distribution.
result_type min () const
Returns the greatest lower bound value of the distribution.
template<typename _UniformRandomNumberGenerator > result_type operator() (_UniformRandomNumberGenerator &__urng)
Generating functions.
template<typename _UniformRandomNumberGenerator > result_type operator() (_UniformRandomNumberGenerator &__urng, const param_type &__p)
param_type param () const
Returns the parameter set of the distribution.
void param (const param_type &__param)
Sets the parameter set of the distribution.
std::vector< double > probabilities () const
Returns the probabilities of the distribution.
void reset ()
Resets the distribution state.

  Friends

template<typename _IntType1 , typename _CharT , typename _Traits > std::basic_ostream< _CharT, _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > &__os, const std::discrete_distribution< _IntType1 > &__x)
Inserts a discrete_distribution random number distribution __x into the output stream __os.
bool operator== (const discrete_distribution &__d1, const discrete_distribution &__d2)
Return true if two discrete distributions have the same parameters.
template<typename _IntType1 , typename _CharT , typename _Traits > std::basic_istream< _CharT, _Traits > & operator>> (std::basic_istream< _CharT, _Traits > &__is, std::discrete_distribution< _IntType1 > &__x)
Extracts a discrete_distribution random number distribution __x from the input stream __is.

Detailed Description

  template<typename _IntType = int>
class std::discrete_distribution< _IntType >"A discrete_distribution random number distribution.

This distribution produces random numbers $ i, 0 d according to the probability mass function $ p(i | p_0, ..., p_{n-1}) = p_i $.

Since
    C++11

Member Typedef Documentation

  template<typename _IntType = int> typedef _IntType std::discrete_distribution< _IntType >::result_type
The type of the range of the distribution.

Member Function Documentation

  template<typename _IntType = int> result_type std::discrete_distribution< _IntType >::max () const [inline]

Returns the least upper bound value of the distribution.

References std::vector< _Tp, _Alloc >::empty(), and std::vector< _Tp, _Alloc >::size().

  template<typename _IntType = int> result_type std::discrete_distribution< _IntType >::min () const [inline]

Returns the greatest lower bound value of the distribution.

  template<typename _IntType = int> template<typename _UniformRandomNumberGenerator > result_type std::discrete_distribution< _IntType >::operator() (_UniformRandomNumberGenerator & __urng) [inline]

Generating functions.

References std::discrete_distribution< _IntType >::operator()().

Referenced by std::discrete_distribution< _IntType >::operator()().

  template<typename _IntType = int> param_type std::discrete_distribution< _IntType >::param () const [inline]

Returns the parameter set of the distribution.

  template<typename _IntType = int> void std::discrete_distribution< _IntType >::param (const param_type & __param) [inline]

Sets the parameter set of the distribution.

Parameters
    __param The new parameter set of the distribution.

  template<typename _IntType = int> std::vector< double > std::discrete_distribution< _IntType >::probabilities () const [inline]

Returns the probabilities of the distribution.

References std::vector< _Tp, _Alloc >::empty().

  template<typename _IntType = int> void std::discrete_distribution< _IntType >::reset () [inline]

Resets the distribution state.

Friends And Related Symbol Documentation

  template<typename _IntType = int> template<typename _IntType1 , typename _CharT , typename _Traits > std::basic_ostream< _CharT, _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > & __os, const std::discrete_distribution< _IntType1 > & __x) [friend]

Inserts a discrete_distribution random number distribution __x into the output stream __os.

Parameters
    __os An output stream.
    __x A discrete_distribution random number distribution.

Returns
    The output stream with the state of __x inserted or in an error state.

  template<typename _IntType = int> bool operator== (const discrete_distribution< _IntType > & __d1, const discrete_distribution< _IntType > & __d2) [friend]

Return true if two discrete distributions have the same parameters.

  template<typename _IntType = int> template<typename _IntType1 , typename _CharT , typename _Traits > std::basic_istream< _CharT, _Traits > & operator>> (std::basic_istream< _CharT, _Traits > & __is, std::discrete_distribution< _IntType1 > & __x) [friend]

Extracts a discrete_distribution random number distribution __x from the input stream __is.

Parameters
    __is An input stream.
    __x A discrete_distribution random number generator engine.

Returns
    The input stream with __x extracted or in an error state.

Author

Generated automatically by Doxygen for libstdc++ from the source code.